version: '3.8'

services:
  db:
    image: postgres:16.0-alpine3.18
    container_name: omnivault_int_db
    # Modification du port pour laisser le port pour la bdd keycloak
    ports:
      - "${DB_PORT}:5432"
    volumes:
      - ${VOLUMES_DIRECTORY}/pg_datas:/var/lib/postgresql/data
    environment:
      POSTGRES_DB: ${DB_NAME}
      POSTGRES_USER: ${DB_USER}
      POSTGRES_PASSWORD: ${DB_PASSWORD}
    restart: always
    deploy:
      resources:
        limits:
          cpus: '0.2'
          memory: 512M
        reservations:
          cpus: '0.1'
          memory: 128M

  backend:
    build: "../../backend"
    container_name: omnivault_int_backend
    depends_on:
      - db
    environment:
    # TODO : NOT SURE TO UNDESTAND WHY IT WORKS 
    #  5432 PORT SHOULD NOT WORK OUTSIDE DB CONTAINER :-/
      - SPRING_DATASOURCE_URL=jdbc:postgresql://db:5432/${DB_NAME}
      - SPRING_DATASOURCE_USERNAME=${DB_USER}
      - SPRING_DATASOURCE_PASSWORD=${DB_PASSWORD}
      - SPRING_JPA_HIBERNATE_DDL_AUTO=update
    ports:
      - "${BACKEND_PORT}:9080"
    deploy:
      resources:
        limits:
          cpus: '1'
          memory: 1024M
        reservations:
          cpus: '0.1'
          memory: 256M
    restart: always
  
  frontend:
    build: "../../frontend"
    container_name: omnivault_int_frontend
    ports:
      - "${FRONTEND_PORT}:80"
    deploy:
      resources:
        limits:
          cpus: '0.1'
          memory: 128M
        reservations:
          cpus: '0.01'
          memory: 32M
    restart: always    
